# SuggestMissingImputedData


## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**imputed_data** | **str** | A CSV string containing a dataset with the columns present in targetColumns or sourceColumns as well as the predictions and uncertainties for missing values in that dataset.  The CSV should contain one column of row headers plus three blocks of equally sized columns:   * The first row contains the column headers   * The first column contains the row headers   * The 1st third of columns after the row headers contains the original incomplete values.   * The 2nd third of columns after the row headers contains the predictions for the missing values.   * The 3rd third of columns after the row headers contains the uncertainties for the predicted values.  The first row of the CSV must contain column headers.  The column header for the row headers is not used. The column headers for the three other blocks of columns should be in one of two formats:   * the first block of column headers are the column headers appearing in the training dataset, the second block has predicted_ as a prefix and the third block has uncertainty_ as a prefix, as shown in the example   * the three blocks column headers will have no prefixes and be identical, for example, &#x60;,w,x,y,z,w,x,y,z,w,x,y,z&#x60;  | 
**source_columns** | **[str]** | A list of column headers which all appear in the model&#39;s training dataset.  Suggested measurements will only be returned from these columns.  Descriptor columns cannot be in sourceColumns.  If not given then suggestions will come from all non-descriptor columns.  The sourceColumns may or may not be distinct from the targetColumns. | [optional] 
**target_columns** | **[str]** | A list of column headers which all appear in the model&#39;s training dataset.  Suggested measurements will be targeted to best improve predictions for these columns.  Descriptor columns cannot be in targetColumns.  If not given then targetColumns will be treated as being all non-descriptor columns.  The targetColumns may or may not be distinct from the sourceColumns. | [optional] 
**exploration_exploitation** | **float** | The desired tradeoff between &#39;exploration&#39;, at 0, or &#39;exploitation&#39; at 1: * &#39;exploration&#39;: suggesting measurements to improve the model across a wide range of different input and output ranges * &#39;exploitation&#39;: suggesting measurements that the model in its current state thinks will give the highest model improvement; typically results in more localised suggestions than &#39;exploration&#39;  | [optional]  if omitted the server will use the default value of 1
**num_suggestions** | **int** | The maximum number of suggested measurements to return that will best improve predictions for the requested targetColumns. | [optional]  if omitted the server will use the default value of 1
**s_factor** | **float, none_type** | Where data is mostly missing, sFactor should take low values - when data is mostly complete, it should take higher values.  If not given or null then sFactor will be set automatically, which is generally recommended.  Adjusting sFactor can make significant differences to the suggestions returned. | [optional] 
**uncertainty_weight** | **float** | Weighting determining the importance of uncertanites for individual data points compared to inter-column relationships when calculating suggested measurements.  If 0 then only column relationships are used to produce suggestions, while if 1 then uncertainties are treated as more important. | [optional]  if omitted the server will use the default value of 0.1
**any string name** | **bool, date, datetime, dict, float, int, list, str, none_type** | any string name can be used but the value must be the correct type | [optional]

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


